##############################################################################
#
# Cascading Folders, for Zope 2.3.1
# Copyright (C) 2001 Spoke Technologies
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author: Randall Kern, randy@spoke.net
# Spoke Technologies, Inc
# 677 120th Ave NE #101
# Bellevue, WA 98005
##############################################################################

"""
Cascading Folders

This is a Zope Product, that provides an object type called a Cascading
Folder.  This object is a standard Folder, that will look for objects in an
uncle if it is not found in this Folder. (The uncle must have the same id.)

The most common use for this Product is to organize images in your site
into separate image folders.  For example:

root
    images (Folder)
        logo.gif (Image)
        nav.gif (Image)
    private (Folder)
        images (Cascading Folder)
            nav.gif (Image)

Given this site, a request for /private/images/logo.gif would fail if private
where a normal Zope Folder.  Using a Cascading Folder, a request for logo.gif
will be passed off to an uncle with the same name, in this case /images.

Author: Randall Kern, randy@spoke.net
"""
__version__ = "0.1"

import Cascade

def initialize(context):
    context.registerClass(
        Cascade.CascadingFolder,
        permission='Add Cascading Folder',
        icon='dtml/cascade.gif',
        constructors=(
            Cascade.addCascadingFolderForm,
            Cascade.addCascadingFolder)
    )

    context.registerHelp()
